import { DynamoDBClientConfig, PutItemOutput } from "@aws-sdk/client-dynamodb";
import { S3ClientConfig, ListBucketsOutput } from "@aws-sdk/client-s3";
import { GetSecretValueRequest, GetSecretValueResponse, SecretsManagerClientConfig } from "@aws-sdk/client-secrets-manager";
export declare function invoke(req: any, service: string, method: string, config: any, params: any): void;
export declare class Service<T> {
    private options?;
    constructor(options?: T);
    protected invoke(method: string, params?: any): any;
}
export declare class SecretsManager extends Service<SecretsManagerClientConfig> {
    getSecretValue(params: GetSecretValueRequest): GetSecretValueResponse;
}
export declare class S3 extends Service<S3ClientConfig> {
    listBuckets(): ListBucketsOutput;
}
export declare class DynamoDB extends Service<DynamoDBClientConfig> {
    putItem(): PutItemOutput;
}
declare const _default: {
    Service: typeof Service;
    SecretsManager: typeof SecretsManager;
    S3: typeof S3;
    DynamoDB: typeof DynamoDB;
};
export default _default;
