/// <reference types="node" />
import { FastJson } from "fast-json";
import { FastJsonOptions } from "fast-json/dist/types";
export interface FastJsonEvent {
    __unparsed_value__: string;
}
export declare enum FastParseType {
    Number = "number",
    String = "string",
    Eid = "eid",
    Raw = "raw",
    Json = "json",
    Array = "array",
    Object = "object"
}
export interface FastParseField {
    field: string;
    type?: FastParseType;
}
export interface FastJsonEnhanced extends FastJson {
    parse: (input: string) => any;
    getPath: () => string[];
    currentObj: any;
}
export declare class FastJsonPlus extends FastJson implements FastJsonEnhanced {
    constructor(opts?: FastJsonOptions);
    currentObj: any;
    isLastPrimitiveAString: boolean;
    parse(input: string): {
        __unparsed_value__: string;
    };
    getPath(): string[];
    private _emitPrimitiveOrString;
}
export declare enum ParserName {
    JsonParse = "JSON.parse",
    Empty = "empty",
    FastJson = "fast-json"
}
export declare let fieldParsers: Record<FastParseType, {
    parse?: (value: string | Buffer) => any;
    set?: (field: string, value: any, setFn: (field: string, value: any, suffix?: string) => void) => void;
}>;
export declare let parsers: Record<ParserName, (settings: any) => (input: string) => any>;
type ParseFunction<T> = (data: string) => T;
interface CreateParserParams<R, T> {
    parser: string | ParseFunction<R>;
    opts: T & {
        botId?: string;
        queue?: string;
    };
}
export declare function createParser<R = any, T = any>(params: CreateParserParams<R, T>): (str: any) => any;
export {};
