/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from 'events';
import { Worker } from 'worker_threads';
/**
 * Pool of worker threads where one thread can be use per task
 */
export declare class WorkerPool extends EventEmitter {
    private id;
    private task;
    private numThreads;
    private workerData;
    workers: Worker[];
    freeWorkers: Worker[];
    messages: Record<string, (worker: Worker, m: any) => void>;
    private onExit;
    constructor(id: string, task: any, numThreads: any, workerData: any, messages?: Record<string, (worker: Worker, m: any) => void>);
    addNewWorker(workerData: any): void;
    listenCount: number;
    runTask(task: any, callback: any): void;
    runTaskAsync<T = void>(task: any): Promise<T>;
    close(): Promise<void>;
}
